c
c
c	 **************************************************
c	real function ax(Jx,Px,Fx,Omx,is)
	real function ax(Jx,Px,Fx,Omx,is)
c
c	this function calculates the coefficients of an expansion
c	of the initial state wavefunction in the basis set of case (a)
c	wavefunctions.
	real Jx,Px,Fx,Omx,N,Pex,Ommaxx
	real a,b,cj,sj
	real rtwo,S
	integer xstate,is
c
	include 'spectra.f'
c    
c
	if (is.eq.0) then
	xstate=instate
	Pex=Pein
	Ommaxx=Ommaxin
	elseif (is.eq.1) then
	xstate=finstate
	Pex=Pefin
	Ommaxx=Ommaxfin
	endif
c
c
	rtwo=1/sqrt(2.)
	ax=0.
	If (Jx.lt.0.0) return
c
	if (xstate.eq.1) then
c	we have a singlet sigma
		S=0.
		if ( Px.eq.(Pex*(-1)**(Jx)) ) ax=1.
c	
	elseif (xstate.eq.2) then
c	we have a singlet pi or delta or phi
		S=0.
		if (Ommaxx.gt.3.) then
			write (6,*) ' higher than singlet phi not implemented'
			write (6,*) ' stopped in ax'
			stop
		elseif (Ommaxx.eq.1.) then
c		here for singlet pi state
		  if (Jx.lt.1.0) return
		  if (Omx.eq.1.0) then
			ax=rtwo 
		  elseif (Omx.eq.-Ommaxx) then
			if (Px.eq.1.0)   ax=Pex*rtwo*((-1)**(Jx+1.))
			if (Px.eq.-1.0)  ax=Pex*rtwo*((-1)**(Jx))
		  endif
		elseif (Ommaxx.eq.2.) then
c		here for singlet delta state
		  if (Jx.lt.2.0) return
		  if (Omx.eq.Ommaxx) then
			ax=rtwo
		  elseif (Omx.eq.-Ommaxx) then
			if (Px.eq.1.0)  ax=Pex*rtwo*((-1)**(Jx))
			if (Px.eq.-1.0) ax=Pex*rtwo*((-1)**(Jx+1.))
		  endif
c		here for singlet phi state
		elseif (Ommaxx.eq.3.) then
		  if (Jx.lt.3.0) return
		  if (Omx.eq.Ommaxx) then
			ax=rtwo
		  elseif (Omx.eq.-Ommaxx) then
			if (Px.eq.1.0)  ax=Pex*rtwo*((-1)**(Jx+1.))
			if (Px.eq.-1.0) ax=Pex*rtwo*((-1)**(Jx))
		  endif
		endif
	elseif (xstate.eq.3) then
c	we have a doublet
		S=0.5
		if (Ommaxx.eq.0.5) then
c			we have a doublet sigma: Zare p 300
c			there are two states, one of each parity, for each J
c			overall parity (see Herzberg p 259) is Pex*(-1.)**(J+S+F)
c			return zero if state is not in Sigma + manifold for Pex=1
c			or in Sigma - manifold for Pex=-1
			If (Px.ne.(-1)**(Jx+S+Fx)) return
			If (Fx.eq.1.) then
c			First do the F(1) states  
			N=Jx-S
				if (Jx.lt.0.5) return
 				if (Omx.eq.Ommaxx)  
	&				ax=rtwo
				if (Omx.eq.-Ommaxx)
	&				ax=rtwo*(-1.)**(Fx+1.)
			Elseif (Fx.eq.2) then
c			Now do the F(2) states 
			N=Jx+S
				if (Jx.lt.0.5) return
 				if (Omx.eq.Ommaxx)  
	&				ax=rtwo
				if (Omx.eq.-Ommaxx)
	&				ax=rtwo*(-1.)**(Fx+1.)
			endif
		elseif (Ommaxx.eq.1.5) then
c			we have a doublet pi: Zare p 302ff (see errata sheet)
c			also see pa 259 of Herzberg diatomics
			If (Fx.eq.1.) then
c			First do the F(1) states  with Om=1/2 in case (a)
			N=Jx-S
				if (Jx.lt.0.5) return
				if (Omx.eq.(Ommaxx-1.))  
	&				ax=rtwo*a(Jx,is)
				if (Omx.eq.-(Ommaxx-1.))
	&				ax=rtwo*a(Jx,is)*Px*(-1.)**(N+Fx) 
 				if (Omx.eq.Ommaxx)  
	&				ax=rtwo*b(Jx,is)
				if (Omx.eq.-Ommaxx)
	&				ax=rtwo*b(Jx,is)*Px*(-1.)**(N+Fx) 
			Elseif (Fx.eq.2) then
c			Now do the F(2) states with Om=3/2 in case (a)
			N=Jx+S
				if (Jx.lt.1.5) return
				if (Omx.eq.(Ommaxx-1.))  
	&				ax=rtwo*(-b(Jx,is))
				  if (Omx.eq.-(Ommaxx-1.))
	&				ax=rtwo*(-b(Jx,is))*Px*(-1.)**(N+Fx) 
 				  if (Omx.eq.Ommaxx)  
	&				ax=rtwo*a(Jx,is)
				  if (Omx.eq.-Ommaxx)
	&				ax=rtwo*a(Jx,is)*Px*(-1.)**(N+Fx) 
			endif
		elseif (Ommaxx.eq.2.5)	then
c		here for a doublet delta state
			If (Fx.eq.1.) then
c			First do the F(1) states  with Om=3/2 in case (a)
			N=Jx-S
				if (Jx.lt.1.5) return
				if (Omx.eq.(Ommaxx-1.))  
	&				ax=rtwo*a(Jx,is)
				if (Omx.eq.-(Ommaxx-1.))
	&				ax=rtwo*a(Jx,is)*Px*(-1.)**(N+Fx+1.) 
 				if (Omx.eq.Ommaxx)  
	&				ax=rtwo*b(Jx,is)
				if (Omx.eq.-Ommaxx)
	&				ax=rtwo*b(Jx,is)*Px*(-1.)**(N+Fx+1.) 
			Elseif (Fx.eq.2) then
c			Now do the F(2) states with Om=5/2 in case (a)
			N=Jx+S
				if (Jx.lt.2.5) return
				if (Omx.eq.(Ommaxx-1.))  
	&				ax=rtwo*(-b(Jx,is))
				  if (Omx.eq.-(Ommaxx-1.))
	&				ax=rtwo*(-b(Jx,is))*Px*(-1.)**(N+Fx+1.) 
 				  if (Omx.eq.Ommaxx)  
	&				ax=rtwo*a(Jx,is)
				  if (Omx.eq.-Ommaxx)
	&				ax=rtwo*a(Jx,is)*Px*(-1.)**(N+Fx+1.) 
			endif
		endif
	elseif (xstate.eq.4) then
c		we have a triplet
		S=1.0
  		if (Ommaxx.eq.1.) then
c		We have a triplet sigma
c		See 
c		B. R. Lewis, S. T. Gibson, M. Emami, and J. H. Carver, 
c		J. Quant. Spectrosc. Radiat. Transf. 40, 1 (1988).
c		or, more relevant,
c		J. B.Tatum and Wilson, Can J. Phys. 49, 2693 (1971)
c		If Pex=1,  triplet sigma plus,  so Parity = (-1)**(J-S)
c		If Pex=-1, triplet sigma minusm so Parity = (-1)**(J-S+1)
c		F(2) has -1 electronic parity, while F(1) and F(3) have +1
c		Thus, Q transitions between two triplet sigma minus or two triplet
c		sigma plus states require
c		one to be F(2) and the other to be F(1) or (F3)
c		There are no P or R transitions from F(2) to F(2). P or R
c		transitions require F(1)-F(1),F(3)-F(3),F(1)-F(3),F(3)-F(1)
			If (Fx.eq.1.) then
			N=Jx+1.
				if (Jx.lt.1.) return
				if (Omx.eq.0.0) ax=cj(Jx,is)
				if (Omx.eq.1.0) ax=rtwo*sj(Jx,is)
				If (Omx.eq.-1.0) ax=rtwo*sj(Jx,is)
			elseif (Fx.eq.2.) then
			N=Jx
				if (Jx.lt.1.) return
				if (Omx.eq.0.0) ax=0.
				if (Omx.eq.1.0) ax=rtwo
				If (Omx.eq.-1.0) ax=-rtwo
			elseif (Fx.eq.3.) then
			N=Jx-1
				if (Jx.lt.0.) return
				if (Omx.eq.0.0) ax=sj(Jx,is)
				if (Omx.eq.1.0) ax=-rtwo*cj(Jx,is)
				If (Omx.eq.-1.0) ax=-rtwo*cj(Jx,is)
			endif
c			set ax back to zero if parity not right
c			See page 238 of Herzberg
			If ( Px.ne.(Pex*(-1)**(N)) ) ax=0.
c			for oxygen, set to zero if upper state doesn't exist
			If ((iO2.eq.1).and.(is.eq.1)) then
c				There is no weight for odd values of N in the 3Sigma - (u)
c				so skip for this line
				If ( Int(N/2.).lt.(N/2.) ) ax=0.
			endif

		else
			write (6,*) ' Only triplet sigma implemented'
			write (6,*) ' stop in Ax'
			stop
		endif
	else
		write (6,*) ' stopped in ax, illegal instate'
		stop
	endif
	return
	end
c
c
c
c		*****************************************************
c	real function a(J,is)
	real function a(J,is)
c		calculates Zare eq. (36) p 303
c		is=0 for ground state, 1 for upper state
	real J,X,Y
	integer is
c
	include 'spectra.f'
c

	If (is.eq.0) Y=SOAin/Bin
	If (is.eq.1) Y=SOAfin/Bfin
	X=sqrt( (4*(J+.5)**2) + Y*(Y-4.)   )
	a=sqrt( (X+(Y-2.))/(2.*X) )
	return
	end
c
c		*****************************************************
c	real function b(J,is)
	real function b(J,is)
c		calculates Zare eq. (37) p 303
c		is = 0 for lower state, 1 for upper
	integer is
	real J,X,Y
c
	include 'spectra.f'
c
	If (is.eq.0) Y=SOAin/Bin
	If (is.eq.1) Y=SOAfin/Bfin
	X=sqrt( (4*(J+.5)**2) + Y*(Y-4.)   )
	b=sqrt( (X-(Y-2.))/(2.*X) )
	return
	end
c
c
c		*****************************************************
c	real function cj(J,is)
	real function cj(J,is)
	real J,P
	integer is
c	call is to Energy(J,P,F,is)
c	P doesn't matter here (lambda doublets unresolved)
	P=1.
	cj=Energy(J,P,2.0,is)-Energy(J,P,1.0,is)
	cj=cj/( Energy(J,P,3.0,is)-Energy(J,P,1.0,is) )
	cj=sqrt(cj)
	return
	end
c
c
c		*****************************************************
c	real function sj(J,is)
	real function sj(J,is)
	real J,P
	integer is
c	call is to Energy(J,P,F,is)
c	P doesn't matter here 
	P=1.
	sj=Energy(J,P,3.0,is)-Energy(J,P,2.0,is)
	sj=sj/( Energy(J,P,3.0,is)-Energy(J,P,1.0,is) )
	sj=sqrt(sj)
	return
	end

c
c		******************************************************
	complex function FL(xnu,Jin,Pin,Fin,Jfin,Pfin,Ffin)
c	xnu is current frequency in spectrum
c	cnu is wavenumber of center of transition
	real xnu,Jin,Pin,Fin,Jfin,Pfin,Ffin
	real cnu
	complex arg1,arg2,arg3
c
	include 'broad.f'
c
	cnu=wavenum(Jin,Pin,Fin,Jfin,Pfin,Ffin)
c
	if (ifano.eq.0) then
c	here for Lorentz broadening
		arg2=cmplx(0.,dnu/2.)
		arg1=cmplx(sqrt((dnu/2.)/3.14159265358979),0.)
		arg3=cmplx(xnu-cnu,0.)
		FL=arg1/(arg3-arg2)
	elseif (ifano.eq.1) then
c	here for Fano lineshapes
		arg1=cmplx(g*(q+((xnu-cnu)/g)),0.)
		arg2=cmplx((xnu-cnu),-g)
		FL=arg1/arg2
	endif
	return
	end
c
c		******************************************************
	real function Pop(J,P,F)
	real J,F,P,gn
	real Nx,h,c,kB
c	calculate population of an initial level
c	doesn't depend on M
c
	include 'broad.f'
	include 'spectra.f'
c
	gn=1.
	Nx=J
	kB=1.38066E-16
	h=6.62618E-27
	c=2.998E10
c
c	This function needs to be modified if nuclear spin 
c	statistics affect the relative populations.  Here's an example
c	of how to go about it
c	we use inuc to select a case; you supply the statements
c	assigning gn
	if (inuc.eq.0) then
c		no spin statistics to worry about
		gn=1.
	elseif (inuc.eq.1) then
c		here's an example for H2 in its electronic ground state.
c		See Herzberg diatomics p. 134
		if (int(J/2.).eq.(J/2.)) then
c		J is even, para hydrogen with gn=1
		gn=1.
		else 
c		J is odd, ortho hydrogen with gn=3
		gn=3.
		endif
	elseif (inuc.eq.2) then
c		modify below for your favorite homonuclear molecule with non-
c		uniform spin statistics
		gn=1.
	elseif (inuc.eq.3) then
c		here for another molecule
		gn=1.
	elseif (inuc.eq.4) then
c		etc.
		gn=1.
	elseif (inuc.eq.5) then
		gn=1.
	elseif (inuc.eq.6) then
		gn=1.
	elseif (inuc.eq.7) then
		gn=1.
	elseif (inuc.eq.8) then
		gn=1.
	elseif (inuc.eq.9) then
		gn=1.
	endif
c
c
c	This bit is for O2 in a triplet sigma minus (g) state 
c	such as its ground electronic state, where even values of N are 
c	missing altogether.  First, we have to determine N, then set gn.
c	This overrides the above business for gn  
c
	If (iO2.eq.1) then
		If (F.eq.1.) Nx=J-1.
		If (F.eq.2.) Nx=J
		If (F.eq.3.) Nx=J+1.
c		There is no weight for even values of N
		If ( Int(Nx/2.).eq.(Nx/2.) ) gn=0.
	endif
c
	Pop=gn*exp( -Energy(J,P,F,0)*h*c/(kB*T) )
	return
	end
c
c
c		******************************************************
	real function Energy(J,P,F,is)
	real J,F,P
	real Y,X
	real xstate,Bx,Dx,SOAx,Ommaxx,gamx,llamx,Pex,Lamx
	integer is,ifx
c
	include 'spectra.f'
c
c
c
c	Write(7,*) ' Entering energy, J,P,F,is= ',J,P,F,is
	Energy=0.
	If (is.eq.0) then
	xstate=instate
	Bx=Bin
	Dx=Din
	SOAx=SOAin
	Ommaxx=Ommaxin
	ifx=ifin
	gamx=gamin
	llamx=llamin
	Pex=Pein
	Lamx=Lamin
	elseif (is.eq.1) then
	xstate=finstate
	Bx=Bfin
	Dx=Dfin
	SOAx=SOAfin
	Ommaxx=Ommaxfin
	ifx=iffin
	gamx=gamfin
	llamx=llamfin
	Pex=Pefin
	Lamx=Lamfin
	endif 

		If (xstate.eq.1) then
c			we have singlet sigma
				Energy=Bx*(J*(J+1.))-Dx*(J*(J+1))**2
		elseif (xstate.eq.2) then
c			we have singlet pi,delta etc
			Energy=Bx*(J*(J+1.)-2.*Ommaxx*Lamx-Lamx**2)
	&			-Dx*(J*(J+1))**2
		elseif (xstate.eq.3) then
c			we have a doublet
			If (Ommaxx.eq.0.5) then
c			we have a doublet sigma
c			Zare page 301
				If (F.eq.2.) then
c				next formula is for the J=N-.5 level  F2
c				it's really B*N*(N+1)-.5*N*gam
				Energy=Bx*(J+.5)*(J+1.5)-.5*gamx*(J+1.5)
				endif
				If (F.eq.1.) then
c				next formula is for the J=N+.5 level F1
c				it's really B*N*(N+1)+.5*N*gam
				Energy=Bx*(J-.5)*(J+.5)+.5*gamx*(J-.5)
				endif
			elseif ((Ommaxx.eq.1.5).or.(Ommaxx.eq.2.5)) then
c			we have a doublet pi or delta
c			Zare p 303, or better, Herzberg V.28 on p 232
				Y=SOAx/Bx
				X=sqrt( (4.*(J+.5)**2) + (Y*(Y-4))*Lamx**2 )
				If (F.eq.1.) then
c				F(1) is for 2Pi1/2 in case (a) limit
c				J=N+1/2
				Energy=Bx*( (J+.5)**2-Lamx**2 - .5*X )
	&				-Dx*J**4+.5*gamx*(J-.5)
				elseif (F.eq.2.) then
c				F(2) is for 2Pi3/2 in case (a) limit
c				J=N-1/2
				Energy=Bx*( (J+.5)**2-Lamx**2 + .5*X )
	&				-Dx*(J+1.)**4-.5*gamx*(J+1.5)
				endif
			elseif (Ommaxx.gt.2.5) then
c			we have a doublet phi
				write (6,*) ' doublet phi not implemented'
				write (6,*) ' stopped in Energy'
				stop
			endif
		elseif (xstate.eq.4) then
c		we have a triplet
			If (Ommaxx.eq.1) then
c			we have a triplet sigma
c			See Tatum and Wilson
				If (F.eq.1.) then
c				N=J-1
					Energy=Bx*J*(J+1.)-(llamx-Bx+.5*gamx)-
	&				sqrt( (llamx-Bx+.5*gamx)**2 +
     &				4.*J*(J+1.)*(Bx-.5*gamx)**2  )
				elseif (F.eq.2.) then
c				N=J
					Energy=Bx*J*(J+1.)
				elseif (F.eq.3.) then
c				N=J+1
					Energy=Bx*J*(J+1.)-(llamx-Bx+.5*gamx)+
	&				sqrt( (llamx-Bx+.5*gamx)**2 +
     &				4.*J*(J+1.)*(Bx-.5*gamx)**2  )
				endif
			elseif (Ommaxx.eq.2) then
c			we have a triplet pi
				write (6,*) ' triplet pi not implemented'
				write (6,*) ' stopped in Energy'
				stop
			endif
		endif
c
	return
	end
c
c
c		******************************************************
c	real function wavenum(Jin,Pin,Fin,Jfin,Pfin,Ffin)
	real function wavenum(Jin,Pin,Fin,Jfin,Pfin,Ffin)
	real Jin,Pin,Fin,Jfin,Pfin,Ffin
c
	include 'spectra.f'
c
	wavenum=Te-Energy(Jin,Pin,Fin,0)+Energy(Jfin,Pfin,Ffin,1)
	return
	end