! Function d(J,N,M,theta)
c	calculates the rotation matrix d^J_{MN}(theta)
c	where theta is in radians
c	Follows formula 3.57 in Zare on p 86
c	here, N is equal to M prime and M is equal to M
c
c
c	NB:  THIS FUNCTION REQUIRES stats.lib AS WELL AS maths.lib
c	(assuming you're compiling with Microsoft Developer Studio)
c
	Real function d(Ji,Ni,Mi,theta)
	real ji,mi,ni,theta
	real*8 j,m,n,dtheta,dnu,coef
	real*8 p1,p2,p3,p4,Fact1,Fact2,Fact3,Fact4 
	real*8 xlnp1,xlnp2,xlnp3,xlnp4,xlnxxx,xxx
	real*8 F1,F2,F3,F4,xlnF1,xlnF2,xlnF3,xlnF4
	integer nu,iln
	dtheta=(theta)
	j=(ji)
	m=(mi)
	n=(ni)

c	write (6,*) ' enter d'
c	write (6,*) Ji, Mi, Ni, theta
c	
c
c	this works up to j=26, higher I haven't tested, but it seems
c	to fall apart.  If you go higher
c		you may have to increase the index on the do 100 nu loop
c	for j values below about 15, you don't need the double precision,
c	so it might be faster without it.
	If(ji.gt.26.4) then
		write(6,*) ' stopped in DJMN.f, Ji>26'
		write(6,*) ' Ji=',ji,'  Ni=',ni,'  Mi=',mi,' theta=',theta
		stop
	endif
	d=0.
	iln=0
c	check to see that M and N are smaller than J
	If (DAbs(M).gt.J) go to 200
	If (DAbs(N).gt.J) go to 200
c
c
c	calculate prefactor
c	write (6,*) ' calculate prefactor'
	if((J+M+1).gt.17.) then
		iln=1
		xlnp1=dlngam(J+M+1.)
	else		
		p1=dgamma(J+M+1.)
		xlnp1=dlog(p1)
	endif
c	write (6,*) ' xlnp1=',xlnp1
	If((J-M+1).gt.17.) then
		iln=1
		xlnp2=dlngam(J-M+1.)
	else
		p2=dgamma(J-M+1.)
		xlnp2=dlog(p2)
	endif
c	write (6,*) ' xlnp2=',xlnp2
	If((J+N+1).gt.17.) then
		iln=1
		xlnp3=dlngam(J+N+1.)
	else
		p3=dgamma(J+N+1.)
		xlnp3=dlog(p3)
	endif
c	write (6,*) ' xlnp3=',xlnp3
	If((J-N+1).gt.17.) then
		iln=1
		xlnp4=dlngam(J-N+1.)
	else
		p4=dgamma(J-N+1.)
		xlnp4=dlog(p4)
	endif
c	write (6,*) ' xlnp4=',xlnp4
c
c			
c	endif
c
c	now loop over nu

	do 100 nu=0,100
c	write (6,*) ' nu=',nu
	dnu=(float(nu))
	Fact1=J-N-dnu
	Fact2=J+M-dnu
	Fact3=dnu+N-M
	Fact4=dnu
c	write (6,*) Fact1, Fact2, Fact3, Fact4
	If (Fact1.lt.0.0.or.Fact2.lt.0.0) go to 101
	If(Fact3.lt.0.0) go to 100
c
c	Need to take one of two routes here, depending on how big J,N are
c	so as to prevent overflow
	If(Fact1+1.gt.17.) then
		iln=1
		xlnF1=dlngam(Fact1+1.)
	else
		F1=dgamma(Fact1+1.)
		xlnF1=dlog(F1)
	endif
	If(Fact2+1.gt.17.) then
		iln=1
		xlnF2=dlngam(Fact2+1.)
	else
		F2=dgamma(Fact2+1.)
		xlnF2=dlog(F2)
	endif
	If(Fact3+1.gt.17.) then
		iln=1
		xlnF3=dlngam(Fact3+1.)
	else
		F3=dgamma(Fact3+1.)
		xlnF3=dlog(F3)
	endif
	If(Fact4+1.gt.17.) then
		iln=1
		xlnF4=dlngam(Fact4+1.)
	else
		F4=dgamma(Fact4+1.)
		xlnF4=dlog(F4)
	endif
	If (iln.eq.1) go to 10
	go to 11
c
10	continue
c	here if we neet to use ln to avoid overflow
c	write(6,*) 'in approx'
	xlnpre=.5*(xlnp1+xlnp2+xlnp3+xlnp4)
	xlnxxx=xlnF1+xlnF2+xlnF3+xlnF4
	coef=((-1)**nu)*dexp(xlnpre-xlnxxx)
	go to 12
c
11	continue
c
c	here if ln not needed (no overflow)
c	
c	write(6,*) 'accurate'
	xxx=F1*F2*F3*F4
	pre=dsqrt(p1*p2*p3*p4)
	If (xxx.eq.0.) then
		write(6,*) 'stopped in djmn'
		stop
	endif
	coef=((-1)**dnu)*pre/xxx
	go to 12
c
c
12	continue
c
	costerm=(dcos(dtheta/2.))**(2.*J+M-N-2.*dnu)
	sinterm=(-dsin(dtheta/2.))**(N-M+2.*dnu)
c	write(6,*) 'calculating d'
	d=d+sngl(coef*costerm*sinterm)
100	continue
101	continue
200	continue
c	write(6,*)'exit d',' d =',d
	return 
	end
