!	Spect is the function called
c
c
c
c
	Real function Spect(Jin,Min,Pin,Fin,Theta,xnu)
c
c	This function does a probability for the above (Theta not used) inputs
c	but for the spectrum only.  It does an incoherent sum (see below)
c
c
c
c
	real Jin,Min,Pin,Fin,Theta,xnu
	real Jfin,Mfin,Pfin,Ffin,Jfbot
	real Prob,dnorm
	real Omin,Omfin
	complex FL,Tamp,xFL
c
	include 'Spectra.f'
c
c
c	write (6,*) ' Entered Spect'

2000	continue
c	Spectrum Only Calculation (icntrl=1)
c	here to do spectrum only.  Note that it's the same procedure as above,
c	except that the sum is not done coherently.  In the regular calculation
c	there are cross terms between the various final rotational levels that are
c	each multiplied by a d(J,N,M,theta) element.  These are important for 
c	determining the angular distribution, but, when integrated over angle, they
c	give zero intensity due to the orthogonality of the d(J,N,M,theta) elements.
c	Thus, the intensity is the same as if the sum had been done incoherently,
c	i.e., without these interference terms.  To get the spectrum only, then,
c	we simply follow the same procedure, but do the abs mag squared for each 
c	rotational transition independently (incoherently).
	Mfin=Min
	Prob=0.
c	prevent a P(0) line, which screws up dnorm
	Jfbot=Jin-1.
	If (Jfbot.lt.0.) Jfbot=Jin
	do 1100 Jfin=Jfbot,Jin+1.,1.
	dnorm=sqrt( (2.*Jfin+1.)/2.	)
	Pfin=-Pin
c	sum over final F levels
	do 1100 Ffin=Ffstart,Ffend,1.
	xFL=FL(xnu,Jin,Pin,Fin,Jfin,Pfin,Ffin)
c	Step One: calculate the complex transition amplitude
	Tamp=cmplx(0.,0.)
	do 1051 Omin=-Ommaxin,Ommaxin,1.
	do 1050 Omfin=-Ommaxfin,Ommaxfin,1.
	Tamp=Tamp+
	&	xFL*
	&	cmplx(
	&	Xaxl(Jin,Pin,Fin,Omin)*XAmplin(Jin,Min,Omin,Omfin,Jfin)*
	&	Xaxu(Jfin,Pfin,Ffin,Omfin)
	&	,0.)
1050	continue
1051	continue
c	note that this statement is now inside the Jfin,Mfin,Pfin,Ffin loops
	Prob=Prob+real( Tamp*conjg(Tamp) )
1100	continue
c
c
c	
c	
c	write (6,*) ' Exiting Spect'
c	write (6,*) ' Prob = ',Prob
c	write (6,*) ' '
c
c
	Spect=Prob
	return
c
c
c
	end
c