c
c
c
c
	real function fitbeta()
	integer icount
	real sold, snew,beta,stpsz
c
	include 'Lookup.f'
	include 'Angdist.f'
c	write (6,*) ' '
c	write (6,*) ' nangdist= ',nangdist
c
c	For fast operation, calculate only theta=0,pi and theta=pi/2
c	figure out beta from the two first points
	if (nangdist.eq.3) then
c	  beta= 2{I(0)-I(pi/2)}/{I(0)+2I(pi/2)}. 
	  fitbeta=2.*(angdist(1)-angdist(2))/(angdist(1)+2.*angdist(2))
	  return
	endif
c	Here if a more extensive angular distribution is wanted (icntrl=2)
c	set initial beta
	icount=1
	stpsz=0.3
	beta=0.
	sold=angdev(nangdist,angdist,beta)
c	write (6,*) ' sold=',sold
	step=stpsz
1020	direct=-1.														   
c	start search
10	continue
	beta=beta+direct*step
c	write (6,*) ' beta=',beta
	if (beta.le.-1.) then
		beta=-1.
		direct=1.
		step=step/2.
		go to 10 		
	elseif (beta.gt.2.) then
		beta=2.
		direct=-1.
		step=step/2.
		go to 10
	endif
	snew=angdev(nangdist,angdist,beta)
c	write (6,*) ' snew=',snew
	if (snew.lt.sold) then
		sold=snew
		go to 10
	elseif (snew.ge.sold) then
		sold=snew
		direct=-1.*direct
		step=step/2.
		if (step.lt.0.00001) go to 100
		go to 10
	endif
100	continue
c	open (8,file='angdist.dat')
c	do 120 i=1,nangdist
c	ang=(float(i-1))*180./(float(nangdist-1))
c	theta=(ang/360.)*2*3.14159265358979
c	write (8,*)theta, angdist(i)
c120	continue
c	close(8)
c
	fitbeta=beta
c	write (6,*) '  exit with fitbeta,sold=',beta,'  ',sold
c	if (1.gt.0) stop
	if (sold.gt.1e-01) then
		write (6,*) ' Bad convergence in fitbeta'
		write (6,*) ' Would have exited with following parameters:'
		write (6,*) '  beta= ',beta,' sold = ',sold
		write (6,*) ' If it traps here, it probably means something'
		write (6,*) '  else in the program has gone wrong'
		write (6,*) ' To check, use icntrl=2 and plot the angular '
		write (6,*) '  distributions.  If they look OK, then you can'
		write (6,*) '  increase the error limit in function fitbeta'
		write (6,*) '  If not, then you need to find the source of the'
		write (6,*) '  error.'
		stop
	endif
	return
	end
c
c
c
c
	real function angdev(nangdist,angdist,beta)
	integer nangdist
	real beta,sum,amp,theta
	dimension angdist(150),testdist(150)
c	set the integrals of the two functions to be the same
c		(leaving out sin(theta)d(theta) term in each)
	sum=0.
	sumamp=0
	do 2 i=1,nangdist
	theta=3.14159265358979*(float(i-1))/(float(nangdist-1))
c
	sumamp=sumamp+angdist(i)
2	sum=sum+(1.+beta*(1.5*(cos(theta)**2)-0.5))
c	write (6,*) 'sum=',sum,' angint=',angint(nangdist,angdist)
	amp=sumamp/sum
c	write (6,*) ' amp=',amp
c	
	Do 10 i=1,nangdist
	theta=3.14159265358979*(float(i-1))/(float(nangdist-1))
	testdist(i)=amp*(1.+beta*(1.5*(cos(theta)**2)-0.5))
10	continue
c
	sum=0.
	do 100 i=1,nangdist
100	sum=sum+(angdist(i)-testdist(i))**2
	angdev=sqrt(sum)/float(nangdist)
	return
	end
c
c
c
	real function angint()
	real sum,theta,ang
c
	include 'Lookup.f'
	include 'Angdist.f'

c
c
c	For fast operation, only theta=0,pi and theta=pi/2  are calculated
c	figure out amplitude from the first two points
	if (nangdist.eq.3) then
c	  A={I(0)+2I(pi/2)}/3 
	  angint=(angdist(1)+2.*angdist(2))/3.
	  return
	endif
c	
	dtheta=3.14159265358979/float(nangdist)
	sum=0.
	do 10 i=1,nangdist
	ang=float(i-1)*180./float(nangdist-1)
	theta=(ang/360.)*2*3.14159265358979
10	sum=sum+angdist(i)*sin(theta)*dtheta
	angint=sum
c	write (6,*) ' angint=',angint
	return 
	end